# Patch file for Bio Menace - use with BM1PATCH.EXE

%ext bm1

###### Shareware release, version 1.1 (unsupported for this pack) ######
%version 1.1s
%abort
###### Freeware release, version 1.1 (supported) ######
%version 1.1

### Load alternate map files ####
%patch $2A1D0 "MBDMPHD.BM1" $00
%patch $2A1DC "Can't open MBDMPHD.BM1!" $00
%patch $2A1F4 "MBDMPTM.BM1" $00
%patch $2A200 "Can't open MBDMPTM.BM1!" $00

### Load alternate graphics files ####
%patch $2A185 "MBDEGAH.BM1" $00
%patch $2A191 "Can't open MBDEGAH.BM1!" $00
%patch $291BD "MBDEGAG.BM1" $00
%patch $291CA "Combining EGA1.BM1 and EGA2.BM1 into MBDEGAG.BM1..."
%patch $29208 "MBDEGAG.BM1" $00
%patch $2922C "MBDEGAG.BM1" $00
%patch $29239 "Can't open MBDEGAG.BM1!" $00
%patch $2A1A9 "MBDEGAG.BM1" $00
%patch $2A1B6 "Cannot open MBDEGAG.BM1!" $00
%patch $2A161 "MBDEGAD.BM1" $00
%patch $2A16D "Can't open MBDEGAD.BM1!" $00

### Change difficulty names ###
%patch $209B0 "normal" $00
%patch $209C0 "hard" $00
%patch $209D0 "tough" $00

%patch $20B80 "Normal" $00
%patch $20B90 "Hard" $00
%patch $20BA0 "Tough" $00

#Change pointers to some mentions difficulty names
%patch $28FB0 $BB $02
%patch $28FB2 $C2 $02
%patch $28FB4 $C7 $02
#And the names themselves...
%patch $291AB "normal" $00
%patch $291B2 "hard" $00
%patch $291B7 "tough" $00
##WARNING: Actually the latest NULL character conflicts...with another NULL one.

#Need to change some pointers again. Practice mode included!
%patch $27A15 $EB $1F
%patch $27A26 $FD $1F
%patch $27A37 $0D $20
%patch $27A48 $1E $20
#And descriptions
%patch $2AEDB "BEGIN NORMAL GAME" $00
%patch $2AEED "BEGIN HARD GAME" $00
%patch $2AEFD "BEGIN TOUGH GAME" $00
%patch $2AF0E "PRACTICE A LEVEL (15 sec)" $00

### Change default (initial) difficulty selected in menu ###
### to the very first (new location of "normal")         ###
%patch $27A7F $00

### Change some text in the loading screen ###
%patch $28003 "B" $1F "i" $1F "o" $1F " " $1F "M" $1F "e" $1F "n" $1F "a" $1F
              "c" $1F "e" $1F ":" $1F " " $1F "M" $1F "a" $1F "n" $1F "g" $1F
              "l" $1F "e" $1F " " $1F "i" $1F "s" $1F " " $1F "b" $1F "a" $1F
              "c" $1F "k" $1F " " $1F "f" $1F "r" $1F "o" $1F "m" $1F " " $1F
              "t" $1F "h" $1F "e" $1F " " $1F "d" $1F "e" $1F "a" $1F "d" $1F
              "," $1F " " $1F "v" $1F "0" $1F "." $1F "9" $1F "9" $1F "," $1F
              " " $1F "2" $1F "0" $1F "1" $1F "2" $1F
%patch $280A9 "B" $1B "a" $1B "s" $1B "e" $1B "d" $1B " " $1B "o" $1B "n" $1B
              " " $1B "B" $1B "i" $1B "o" $1B " " $1B "M" $1B "e" $1B "n" $1B
              "a" $1B "c" $1B "e" $1B " " $1B "f" $1B "r" $1B "o" $1B "m" $1B
              " " $1B "A" $1B "p" $1B "o" $1B "g" $1B "e" $1B "e" $1B " " $1B
              "S" $1B "o" $1B "f" $1B "t" $1B "w" $1B "a" $1B "r" $1B "e" $1B
              "," $1B " " $1B "L" $1B "t" $1B "d" $1B "." $1B

#### Game songs ###

#Song values:
#00: Crusing 01: Weasel
#02: Bio Theme 1 03: Snake Save
#04: Dirty Water 05: Rockin' It
#06: Bayou 07: Roboty
#08: Prisoner 09: Dr. Shock
#0A: Chasing 0B: Like It Was
#0C: Apogee Fanfare 0D: Saved
#0E: Resting 0F: Can't Get
#10: Non Vince 11: The City

%patch $2942E $11 $00
              $02 $00
              $05 $00
              $06 $00
              $0A $00
              $03 $00
              $04 $00
              $01 $00
              $00 $00
              $08 $00
              $07 $00
              $09 $00
              $0B $00
              $0C $00
%patch $2944A $0D $00
              $0B $00
              $0F $00
              $10 $00
              $0E $00
              $FF $FF

#Other music played, using the other patch mentioned later:
#%patch $3C96 $12 $00 #Startup technical help
#%patch $3CB1 $12 $00 #Startup copyright notice
#%patch $4EAD $0C $00 #End of game story
#%patch $CABA $11 $00 #Invincibility mode
#%patch $D96D $0E $00 #Skull Man defeat (mid-boss)
####INCOMPATIBLE DUE TO NEW PATCHES DEALING WITH TEXT
##%patch $FB24 $0F $00 #Discussion with a hostage
##%patch $FFDD $0F $00 #Message from a robot (makes appearances in episodes 2-3)
####
#%patch $1E3F6 $10 $00 #In-game menu
#%patch $1E517 $10 $00 #Currently unclear purpose. By default, same as menu song.
%patch $3C96 $2B $00 #Startup technical help
%patch $3CB1 $2B $00 #Startup copyright notice
%patch $4EAD $24 $00 #End of game story
%patch $CABA $29 $00 #Invincibility mode
%patch $D96D $26 $00 #Skull Man defeat (mid-boss)
###INCOMPATIBLE DUE TO NEW PATCHES DEALING WITH TEXT
#%patch $FB24 $2A $00 #Discussion with a hostage
#%patch $FFDD $2A $00 #Message from a robot (makes appearances in episodes 2-3)
###
%patch $1E3F6 $28 $00 #In-game menu
%patch $1E517 $28 $00 #Currently unclear purpose. By default, same as menu song.

#Title screen songs:
%patch $3CD4 $04 #Play on the first screen
%patch $3CEF $04 #Check if playing before loading the second screen
%patch $3CF3 $04 #Play on second (if the previously mentioned check tells to)
%patch $3D0E $04 #Check if playing before loading the third screen
%patch $3D12 $04 #Play on third (if the check tells to)

#Secret levels song:
#%patch $69C2 $04 $00

### New logics for song assignments ###
###1. For any track below 16 (10h), play as usual.
###2. For track 16 (10h), replace with 14 (0Eh).
###3. For tracks above 24 (18h), substract 24 (18h) from its value.
###4. For any OTHER track above 19 (13h), replace with 4.
###5. for any other track, just replace with track value 16 (10h).

%patch $69B7 $89 $F0 #Store the current value of si (proposed song) in ax
             #Now we concentrate in al only (and not ax) - thus saving space.
             $3C $10 #Compare to $10
             $72 $1C #If less, jump and don't change
             $74 $0C #If equals, jump and change to $0E
             $3C $18 #Compare to $18
             $77 $12 #If above, jump and substract $18
             $3C $13 #Compare to $13
             $77 $08 #If above, jump and change to $04

             $B0 $10 #Otherwise, just set to $10
             $EB $06

             $B0 $0E #Here we change from $10 to $0E
             $EB $02
             $B0 $04 #Here we change to $04 from a track value > $13 (not > $18)

             $89 $C6 #Actually store current value of ax in si
             $EB $04

             $83 $EE $18 #Here we substract $18 from a track value above $18
             $90

### ***OLD*** New logics for song assignments ###
###1. Upon loading any track below 17 (11h), play as usual.
###2. Upon loading any track above 24 (18h), substract 24 (18h) from its value.
###3. For any other track, just replace with track value 4.

##%patch $69B9 $14
#%patch $69B9 $11         #Below 11h, continue...
#%patch $69C2 $04 $00     #Set to 4, if not below 11h nor above 18h

#%patch $69C9 $83 $EE $18 #Here we're above 18h anyway. Substract 18h...
#%patch $69CC $EB $0B     #...and then continue as usual.

### Health patches ###

#On Hard difficulty, always begin a new level with 2 health points.
%patch $9EE5 $02 $00

#Ensure that whenever a level is loaded, we always begin with max health.
#How? Well, do NOT change the value of some variable.
#
#TODO: Know that block with spikes on the bottom, then begins to move slowly
#as the player passes through certain tiles
#(one from original last secret level; Also used as a trap in ep2 and ep3).
#Well it MIGHT read that value and be affected in some way,
#upon collision with the player. We're just a bit unsure how...
#%patch $9EAD $90 $90 $90 $90 $90 $90

#Err... another trial. This time, ALWAYS jump to the code setting the health.
#(and also that variable)
%patch $9E9F $EB $0C

### Try patching Skull Man's hands, actually fixing a bug.
### Reproduced when hands are still and the right one is shot.
%patch $14674 $FE
%patch $14675 $75

##### A few text patches coming now #####

###To begin with, right now, for any shard lock, when you try accessing it
###while not having the right shard, you might get a message.
###Duplicates of the same message are used by default.
###Lets change pointers so the very same message is used now.
###Common message: "You don't have the right shard!\n"
#%patch $A55C $22 $0A #Actually the default here
%patch $A5B9 $22 $0A #Default is $43 $0A
%patch $A616 $22 $0A #Default is $64 $0A
%patch $A673 $22 $0A #Default is $85 $0A
###Now lets do the same but for "You don't have a key for this!\n"
#%patch $A06A $B2 $09 #The default
%patch $A501 $B2 $09 #Default is $02 $0A
###And again, but for "Find out where these crystal shards go.\n"
#%patch $C5EC $FA $0C #The default
%patch $C63E $FA $0C #Default is $23 $0D
%patch $C690 $FA $0C #Default is $4C $0D
%patch $C6E2 $FA $0C #Default is $75 $0D
###Yet again, with "Throw grenades to blow up monsters!\n"
#%patch $C3F5 $5C $0C #The default
%patch $C772 $5C $0C #Default is $BA $0D

###And now, lets apply some "basic" text changes. Beginning with level names.

### Level names ###
#Split to 2 parts: One where the original level names are located,
#and another one overriting some unnecessary text.

#Part 1
%patch $29F52 $94 $10
%patch $29F84 "Back In Downtown" $00
%patch $29F54 $A5 $10
%patch $29F95 "Park Under Invasion" $00
%patch $29F56 $B9 $10
%patch $29FA9 "Trapped Way Deep" $00
%patch $29F58 $CA $10
%patch $29FBA "Skull's Fun Place" $00
%patch $29F5A $DC $10
%patch $29FCC "Skull Wants Revenge" $00
%patch $29F5C $F0 $10
%patch $29FE0 "Skull's Basement" $00
%patch $29F5E $01 $11
%patch $29FF1 "It Smells Bad" $00
%patch $29F60 $0F $11
%patch $29FFF "Touch The Sky" $00
#Part 2 - Overriding a copy of the "You don't have a key for this!\n" message
%patch $29F62 $02 $0A
%patch $298F2 "The Neighbors" $00
%patch $29F64 $10 $0A
%patch $29900 "Mangle's Lab" $00
#Part 3 - Overriding copies of the "You don't have the right shard!\n" message
%patch $29F66 $43 $0A
%patch $29933 "Town Under Attack" $00
%patch $29F68 $55 $0A
%patch $29945 "Robotic Arena" $00
#Part 3b - Now adding new level name entries whereever we want one.
#%patch $29F72 $63 $0A
%patch $29F76 $63 $0A
%patch $29953 "Tunnel To Where?" $00
%patch $29F70 $74 $0A
%patch $29964 "Now After Invasion" $00
%patch $29F78 $87 $0A
%patch $29977 "Something's Fishy" $00
##A LITTLE WARNING:
##This overrites some of the "You must rescue the hostage first" message!
##However, we're going to fix that very soon...
#%patch $29F76 $99 $0A
%patch $29F72 $99 $0A
%patch $29989 "Is It Really Over?" $00

### Change the message "You must rescue the hostage first!\n"
### to "You don't have the exit key!\n"
### We'd need to re-position it a bit due to the recent level name patch.
### Very luckily, it TIGHTLY fits in place after moving!!!
%patch $A6D0 $AC $0A #Default position in dseg is just $A6 $0A
%patch $2999C "You don't have the exit key!" $0A $00

### We'd like to modify the code dealing with the displaying of level name or
### some other thing (e.g. "Secret Level") in order to accomplish these goals:
### 1. For all demo playbacks, display "Cutscene".
### By default, "DEMO" for all, excluding level 24 where it's "Secret Level".
### 2. In the table of song pointers (indexed by level), (re)set level 16 (10h)
### track to a specific value.
### 3. BUT WATCH OUT!!! In the above patching of song loading mechanism,
### we're REMAPPING track 16 (10h) to 14 (0Eh)! So, we really want 0Eh.
### We'd do it as the song is to be modified during an encounter with Mangle.

##We'd rather begin with the music thing, basically "compressing" code
##in order to make some room. Luckily, we can apply very few changes.

%patch $586F $74 $0F #Modify some jump
             $6A $00 #Save a byte here
             $9A $0C $00 $1FBDRW
             $58     #Save another byte
             $C6 $06 $E1 $44 $02
             $EB $08 #Modify some other jump

             $6A $01 #Save two bytes
             $9A $0C $00 $1FBDRW
             $58     #Save yet another byte

             $C7 $06 $5A $05 $0D $00 #Now modify music table entry
#            $C7 $06 $5E $05 $0D $00 #Now modify music table entry
             $FF $36 $C0 $44
             $9A $04 $13 $14AARW
             $58     #Save one more byte

##Now we continue with the level names.
#First change: Avoid from displaying "Secret Level" by always making some jump.
%patch $58CF $EB $12
#Second change: Display "Cutscene" instead of "DEMO". We'll use data space
#allocated for copies of the "Find out where these crystal shards go.\n" message.
%patch $58EB $23 $0D #Originally $28 $05, pointing to "DEMO"
%patch $29C13 "Cutscene" $00

### A side effect: When actually entering a secret level,
### one may not get the "Secret Level" message.
### Solution: Assign these using the standard table of level name pointers.
### For levels 20-23 (14h-17h), point to an occurrence of
### the "Secret Level" string. We have two so lets choose one of them.
%patch $29F7A $1B $05
%patch $29F7C $1B $05
%patch $29F7E $1B $05
%patch $29F80 $1B $05

### Change "Cool!  Land mines!\n" into "Is that a keycard?\n".
### We have enough room to use the original text space.
%patch $29CF6 "Is that a keycard?\n" $00

### Change "This switch activates a bridge.\n" into:
### "This switch toggles a beam or a bridge.\n". Requires more space.
## Lets use one from copies of "Find out where these crystal shards go.\n".
%patch $A8F5 $2C $0D #Originally $37 $0B
%patch $29C1C "This switch toggles a beam or a bridge." $0A $00

#Hoping this works as expected, lets try disabling the FILE_ID.DIZ check
#(for legal / software piracy) by skipping it and "always accepting".
#That is, always setting some value to 0.
%patch $4011 $31 $C0 $90 $90

#What does human respawn (exit key)?
#%patch $CBF3 $50 $00 #Exit key

#Skip Apogee Fanfare demo. Takes affect on any demo replay of it!
#%patch $3C7E $90 $90 $90 $90 $90

#Skip technical help
%patch $3CA9 $90 $90 $90 $90 $90

#Skip copyright notice
%patch $3CBF $90 $90 $90 $90 $90

#On title screens, skip the screen with:
#"Some monsters you'll meet in games 2 and 3."
#A little different patch this time, changing jump table.
#Avoiding a potential unnecessary music playback.
%patch $3D94 $AB $04

#Skip demo playback number 2 (by default, level 0)
%patch $3D33 $90 $90 $90 $90 $90
#Skip demo playback number 3 (by default, level 4)
%patch $3D40 $90 $90 $90 $90 $90

###All demos block keyboard? For any level, excluding 12 (0Ch).
###PROBLEM: Can quit some of them upon being done (in an improper way).
#%patch $6E1E $EB $2E
%patch $6E22 $0C #Compare level number to this
%patch $6E23 $75 #If different, jump to somewhere
#%patch $6E25 $90 $90 $90 $90 $90 $90 $90
###OK, LETS TRY ADDING SOMETHING... This time to the demo playback function.
###Receives demo index as an argument. Usually compares to 4. Don't?
#%patch $515B $EB $0A
#%patch $5241 $EB $11
%patch $515D $00 #If demo index is 0 (high scores table)
%patch $515E $75 #Do NOT jump. Otherwise, do.
###A different thing
%patch $5243 $00 #If demo index is 0...
%patch $5244 $75 #Do NOT jump; Otherwise, jump.
%patch $5246 $90 $90 $90 $90 $90 #Omit some code...
%patch $5251 $00 #Compare for the second time to 0
%patch $5252 $74 #But jump this time if we want.

###IMPORTANT! You know the electric beams in E1L10 (level number counted from 0)?
###I mean, the ones deactivated using blue and cyan shards?
###You may notice that upon doing that, some top animating faces also "turns off".
###The following patch changes the level where it can happen.
###Works for blue and cyan shard locks only!! (But can be patch nearby to, say, other two things).
#%patch $AA50 $0A #Default
%patch $AA50 $0B
###If we're here though...
#%patch $AA56 $09 #Make that work with blue shard locks (9).
#%patch $AA5C $0C #Also make that work with cyan shard locks (0Ch).

###Flip the large mechanic robot so it shoots to the right instead of the left.
###Also requires the flipping of everything shot.
###Lets begin with the robot itself though...
#%patch $13134 $01 $00 #Default initial direction of RIGHT.
%patch $13134 $FF $FF #Initial direction is now LEFT.
#%patch $235BC $08 $00 #Maybe some way to move for seg269
#%patch $235BC $F8 $FF #Flip? Hmm maybe we don't want to. Causes robot to stay stuck. Basically tells to "move in opposite direction".
#%patch $235DC $08 $00 #Probably the same
#%patch $235DC $F8 $FF #So we can flip, but lets not do it for now.
#%patch $1335C $FF $FF #Rocket being shot to the left...
%patch $1335C $01 $00 #Now shoot to the right!
#%patch $1333F $80 $00 #Relative horizontal position for spawned rocket shot.
%patch $1333F $80 $04 #Need to increase, shooting from a bit different relative location.
#%patch $13401 $FF $FF #That little creature being shot diagonially, by default to the top-left.
%patch $13401 $01 $00 #Now shoot right instead of left!
#%patch $133E4 $80 $02 #Again relative location, but for the diagonal thing this time.
%patch $133E4 $80 $02 #Also need to move, but just a bit. Or not?

###Change land mines into a new (third) kind of a key. Sort of.
#%patch $11B37 $24 $00 #Default
#%patch $11B37 $1A $00
#%patch $2A0C2 $DB $00 #Default cache
%patch $2A0C2 $D5 $00 #New cache alternative - third type of key.
##Now we want the player to retrieve such a key upon touching it...
%patch $CD2B $87 $08
##Fix the key tile as it appears after collection. Shouldn't be collectable.
#%patch $CC1D $06 $00 #Original code
%patch $CC1D $02 $00
##Also try changing a bit so it isn't hidden behind the player.
%patch $CC1F $C7 $44 $22 $03 $00
##Change sound effect so it's the same as for the other keys.
#%patch $CC0C $0E $00 #Original code
%patch $CC0C $0F $00
##Show original Land Mine message, by jumping to the original Land Mide code -
##- HOPING WE HAVEN'T OVERWRITTEN IT FOR DIFFERENT PURPOSES! (Apparently not)
%patch $CC36 $FA $FB

###Now we want to change third key lock into a switch.
###The tileinfo (tile property) value for the lock is 4.
###So, first (in the beginning of sub_9F46), we need to add this to the list of switches.
###We'll do a "smart" patching taking advantage of the existing space only.
%patch $9F79 $83 $FF $03 #Key card?
             $74 $2D
             $83 $FF $13 #Platform switch?
             $74 $28
             $83 $FF $12 #Bridge switch?
             $74 $23
             #Now the change comes...lets relocate a few comparisons to here, first. 
             $83 $FF $17 #Combo switch?
             $74 $1E
             $83 $FF $0E #Place to detonate nuclear bomb?
             $74 $19
             $83 $FF $0F #Exit key switch?
             $74 $14
             #Add the new kind of key (now used as another keycard).
             $83 $FF $04 #The newly added kind of switch?
             $74 $0F
             #Now we're left with values 9, A, B, C. Lets have them in a range!
             $83 $FF $09
             $7C $47
             $83 $FF $0C
             $7F $42
             #Originally, another comparison had to come here. Lets put NOPs...
             $90 $90 $90 $90 $90
###However, that's not enough! Now in some other code (loc_A437), need to patch too.
###This time, deals with the switches only (shard/key or not).
###But we don't have the room for code? Well, we can do two things:
###1. A little of the original code for third unused key is now freed; Or rather, the land mines.
###2. Re-arrange code dealing with the access card, now to be used for the new kind of key as well.
###Luckily, segment is the same, so it's easy to jump to there; Update jumptable accordingly.
%patch $ACD0 $03 $02
###Now we need to patch that code... simple part is: Jump back to original code if not having a key.
###Lets use the original access card code that prints message to player (if not having card).
###Its location is seg008:06BF.
%patch $A048 $0F $84 $B3 $04
###If we do have... Not having much room, lets just update the keys count for now.
%patch $A04C $FF $0E $D9 $44
###Now we need to take care of original code space. Lets go back to the code
###starting on loc_A437, this time to the portion dealing with access card.
###Or rather, a specific location. Soon we see why... go to location $A51E (seg008:06DE).
%patch $A050 $E9 $CB $04
###Now to patch access card code. First, on the *very beginning*, decrease the
###amount of access cards by 1. Why? Because we don't want it to execute for the new key.
%patch $A51A $FF $0E $C5 $44
###Now we need to "shift" the rest of the code so it works for both kinds of keys.
###At least, up to the original location of the opcode decreasing card amount (and including).
%patch $A51E $B8 $01 $00
             $50
             $B8 $01 $00
             $50
             $8B $5E $06
             $8B $47 $30
             $40
             $50
             $8B $5E $06
             $FF $77 $36
             $B8 $01 $00
             $50
             $16
             $8D $46 $FA
             $50
             $9A $10 $0F $186BRW
             $83 $C4 $0E
###Almost done; Just a little more thing.
###On to $A9C4 seg008:0B84, it compares to list of different kinds of switches,
###used for toggling off electric beams. We want to add the new one in some way...
###Even if we try compressing using register ax instead of [bp-2],
###we'd still have not enough room. So, lets jump skip this section and jump to
###the correct place directly! (from the original code portion we've just patched).
%patch $A550 $E9 $8C $04

###BUT WAIT!!! We're not yet done!
###We wouldn't like the player to go near the new switch and get the message:
###Push <UP> to enter or open a door.
###While we'd probably just disable almost all such kinds of messages,
###lets do it here right now...
###Somewhere in sub_C144, in the jump table.
%patch $C2C1 $77 $24

###Now, some work is done for a "new" boss - Dr. Mangle, but as a floating head!
###Basically, we keep the floating head as type 0Dh,
###while we change Mangle's controlled monster to be of type 21h (same as Skull Man).
###It does mean, among things, that in order to have "boss messages" working as
###expected, the head is really required (monster does nothing).

##First, about the "boss messages" code...lets do it so, usually, the head
##would just disappear, but on a specific level a few things would be initialized
##before a match begins.
##Unfortunately, needs some "re-engineering", as again we don't have enough room.
##Luckily there are two loops which are unnecessary (looking for objects of type 0Dh; i.e. Mangle).
##They're almost the duplicates of a different loop. True, they may go to a bit different place if object
##isn't found. But it couldn't happen cause if any of them executes, then another earlier loop has finished
##successfully, locating an object of type 0Dh!
##OK lets rewrite...

%patch $A7F8 $8B $1E $48 $44 $8B $5F $58 $09 $DB $0F $84 $C3 $04 $81 $3F $0D
             $00 $75 $F1 $53 $B8 $18 $00 $50 $9A $A5 $0A $1A3ERW $44 $44 $9A
             $84 $0D $0F2FRW $81 $3E $C0 $44

#            $0B $00 #Level where monster does not disappear
             $10 $00 #Level where monster does not disappear

             $74 $09 $9A $DA $0B $05D2RW
                 $5B $E9 $9B $04 $5B $C7 $47 $1C $00 $00 $C7 $47 $40 $01 $00
             $C7 $47 $48 $28 $00 $B8 $C8 $00 $89 $47 $44 $A3 $B8 $00 $C7 $06
             $BA $00 $FF $FF $BB $14 $00 $99 $F7 $FB $48 $A3 $60 $43 $C7 $06
             $A0 $09 $01 $00 $E9 $69 $04

##Now, there's a little problem: When Dr. Mangle (in head form) changes so
##it's ready to fight, i's possible to get a "Placed an uncached sprite" error!
##That's because, initially, it may randomly shoot a diagonal thing,
##also shot by the large robot (which we've flipped).
##It is the original behavior in BM2, but there are no caching issues
##as there are instances of the robot.
##As I don't see it being much relevant, lets just avoid it now.
%patch $114EE $90 $90 $90 $90 $90 $90 $90 $90 $90

##And now, how to make it not respond to grenade?
##We have one piece of code (loc_EA5E) with another case (type 0D) to add.
##We have no much room, though... well, luckily,
##IF we apply the horizontal platform patch, together with platforms following
##paths, then we have new room to use!!
##We just *copy* the function to there, and modify it a bit.

##...Unfortunately, well, isn't it quite wasteful of space?
##Yes! Therefore, we don't copy the code. However, the addition would be done
##in some other, freed, place (the platform stuff).
##And we simply *jump* to there, and back.

#First, jump to new location if needed.
%patch $EA7F  $E9 $60 $1E
#Now writing to the place of platform code (now freed).
%patch $108E2 $83 $3C $28     #If collides with that red monster...
              $0F $84 $B9 $E1 #Jump to relevant place and practically skip.
              $83 $3C $0D     #If collides with Dr. Mangle (now as a flying head)...
              $0F $84 $B2 $E1 #Same
              $E9 $91 $E1     #Otherwise jump to different place

##Now we also need to do it for the grenades themselves, somewhere after loc_E9ED
##(and not just what they leave after being thrown).
##Again using space freed from the original platform code, we'd use the same
##technique.

#First, jump to new location if needed.
%patch $E9FE  $E9 $F2 $1E
#Now, again, writing to the place of the original platform code.
%patch $108F3 $83 $3D $15     #If collides with a block that the player can push...
              $0F $84 $60 $E1 #Jump to relevant place, thus skipping the block.
              $83 $3D $0D     #If collides with Dr. Mangle...
              $0F $84 $59 $E1 #Skip it.
              $E9 $FF $E0     #Otherwise continue as usual.

##Well, apparently, that isn't enough. There are a few little "pieces" of fire
##left out by the grenade which might affect as well. Code at loc_E454.
##So, lets repeat the same technique!

#First, jump to new location if needed.
%patch $E47A  $E9 $87 $24
#Now writing to the place of platform code (now freed).
%patch $10904 $83 $3C $28     #If collides with that red monster...
              $0F $84 $9A $DB #Jump to relevant place and practically skip.
              $83 $3C $0D     #If collides with Dr. Mangle (now as a flying head)...
              $0F $84 $93 $DB #Same
              $E9 $6A $DB     #Otherwise jump to different place

##OK that's good. There are still a few things left for the Mangle code, though.
##Among things, we'd like to give it a death sequence. Also update health bar,
##for seg197 (Mangle's head in "attack" mode), though we don't have so much room...
##So, lets apply the same trick again using freed platform code.

#First, jump to new place.
%patch $11529 $E9 $E9 $F3
#Now write the code, dealing with the score bar.
%patch $10915 $8B $76 $06
              $8B $44 $44     #Store health
              $3B $06 $B8 $00 #Compare to health bar.
              $74 $0C         #If equal, jump...
              $A1 $B8 $00     #Now update...
              $A3 $BA $00
              $8B $44 $44
              $A3 $B8 $00
              $E9 $FC $0B     #Jump back to our code.

##However, what's next? In some other place we set the "death" segment to seg203,
##changing it so it uses a death sequence similar to the large robot's.
##But we want the level to end upon the end of the sequence!
##We could use seg204 and its existing code, which, among things, triggers "end of level".
##But if we can save that segment for other potential usages... (doesn't have to be a sprite frame!)
##Well, no problem, lets patch the robot's death sequence code! Oh wait...
##We don't have much room to move stuff. OK, lets use the room of the platform code...
##Ah, but we've practically filled it!
##SOLUTION: Use freed land mine collection code!!

#Begin with jumping...
%patch $12FE4 $EA $75 $04 $0C38RW
#Now add new code (in place of land mine collection)
%patch $C7F5 $81 $7C $1E $22D5RW #Is segment seg203? (Mangle's death sequence).
             $74 $10             #If yes jump just a bit further to update something...
             #Original robot death code copied...
             $B8 $17 $00
             $50
             $9A $A5 $0A $1A3ERW #Produce death sound
             $44
             $44
             $EA $CF $00 $12F2RW #Jump back to code and continue as usual.
             #A little addition of code for Mangle's death
             $C7 $06 $58 $44 $02 $00 #Trigger level completion
             $EA $E9 $00 $12F2RW #Jump back to code, but a different place; We want to finish.

##More stuff for Mangle. Now that its segment is updated (to seg203) upon death,
##lets make it...work like that large robot.

%patch $22D50 $57 $01 $57 $01 #Change frame
%patch $22D54 $03 $00
#%patch $22D58 $00 $00         #No need
%patch $22D5A $00 $00         #Same
#%patch $22D5A $06 $00         #Same
%patch $22D60 $00 $00 $12F2RW #For now, same function as large robot's death.
%patch $22D6C $00 $00 $22D5RW #Don't change segment after some time.

###Time to take care of the monster (originally controlled by Dr. Mangle from within).
###Ensure that the monster itself does NOT disappear after showing boss message.
###How? Change its "type" from 0xD to, say... 0x21 (Skull Man).
###SIDE EFFECT: Doesn't leave a nuclear bomb after death (if we want so).
###But no worry we change that very soon...
%patch $116DE $21 $00
#Don't forget! Ensure that it can be hit from the beginning! (Not original behavior)
%patch $11759 $01 $00

##Instead of mangle turning into a monster, begin with the monster immediately!
%patch $11708 $00 $FD #Monster should be located with the correct height.
%patch $11724 $22CFRW #Change segment so we begin with an actual monster.

###Some changes for death code, dealing with Skull Man, monster and Dr. Mangle.
###If an object of type 0Dh is killed (now Dr. Mangle's head, not the monster anymore),
###then we progress as before, but not producing a sound effect. Also changing segment.
%patch $D936 $C7 $44 $1E $22D5RW #Change segment...
             $C7 $04 $02 $00     #Update sprite type to 2...
             $EB $35             #Then remove monster energy bar and its energy, by jumping to existing code (tricky...)
###OK now we have a little more room. Originally code just for Skull Man,
###but now it'd be for both the Skull Man and the monster (not Mangle anymore).
###Same type for both (0x21).
###First, though, lets update the jump table entry... to offset 15C1
%patch $DA91 $C1 $15
###Now we can write the code...
###Will depend on level number. For instance, if 13h (19), act like monster. Else be Skull Man.
%patch $D941 $83 $3E $C0 $44 #Compare level number to...

             $13 #Is it level 13h (1

             $74 $0E             #If yes, jump to somewhere...
             ##Skull Man
             $BF $88 $13             #Add 5000 points to player's score
             $C7 $06 $D8 $11 $01 $00 #Notify Skull's hands that the fight has ended.
             $B8 $1A $00             #Spawn a blue shard on death.
             $EB $06                 #Jump to common code
             ##Monster (originally controlled by Dr. Mangle from within)
             $BF $98 $3A #Add 15000 points to player's score
             $B8 $4B $00 #Spawn a nuclear bomb on death.
             ##Shared code for both
             $50                     #Prepare arguments for spawn function.
             $FF $74 $30
             $FF $74 $36
             $9A $D5 $00 $119ARW     #Call spawn function
             $83 $C4 $06             #Free function resources (actually move stack pointer)
             $B8 $0E $00             #Set victory music track
             $50                     #Push to stack
             $9A $89 $0C $05D2RW     #Call music function
             $44                     #Free function resources
             $44
             $C7 $44 $40 $00 $00     #Tell that the creature can't be hit by weapons
             $C7 $06 $B8 $00 $E7 $03 #Remove energy bar from the score box
             $EB $17                 #Jump to a later section in the code.

###Make it so you may collect the blue shard right away after killing Skull Man
###(so you don't need to press the "Up" key).
###By default, done on levels 6 and 11 (counting from 0).
#%patch $C5AB $06
%patch $C5AB $04
#%patch $C5B2 $0B
%patch $C5B2 $04

###When a nuclear bomb is detonated, level end is triggered.
###We change code so we still get message with sound, but also trigger
###end of level. Among things we're SHIFTING original code.
%patch $A74A $50
             $8B $5E $06
             $8B $47 $30
             $40
             $50
             $C7 $06 $58 $44 $02 $00 #Finally trigger end of level

##### Platform stuff #####

###On the initialization of map where it's checking all sprites, make it so
###a few unused sprites would be used for path following platforms now.
###Practically, initialization code shared with the ordinary
###horizontally/vertically moving platforms would be called.

%patch $FA1B $EB $04 #Sprite matches platform following a path, initially down.
%patch $FA1D $EB $04 #Sprite matches platform following a path, initially left.

###Change platform goplat initialization so we take care of the one following
###paths as well (in addition to the vertically/horizontally moving platforms)

%patch $10621 $C7 $47 $02 $02 $00 $C7 $47 $22 $01 $00 $8B $46 $06 $B1 $08 $D3
              $E0 $89 $47 $0A $8B $46 $08 $B1 $08 $D3 $E0 $89 $47 $0C $57 $8B
              $7E $0A $81 $FF $03 $00 $77 $2A $C7 $47 $44 $00 $00 $C1 $E7 $02
              $2E $8B $85 $C3 $03 $89 $47 $0E $2E $8B $85 $C5 $03 $89 $47 $10
              $EB $40 $00 $00 $FF $FF $01 $00 $00 $00 $00 $00 $01 $00 $FF $FF
              $00 $00 $C7 $47 $44 $32 $00 $8B $5E $08 $D1 $E3 $8B $9F $12 $B8
              $D1 $EB $D1 $E3 $8E $06 $C2 $72 $8B $46 $06 $D1 $E0 $01 $C3 $8B
              $46 $0A $05 $46 $00 $26 $89 $07 $8B $1E $50 $44 $2D $3A $00 $89
              $47 $48 $5F $E9 $07 $00

###Patch for horizontally moving goplats (platforms). Basically, ensures that
###such goplats do respond to blocking sprites as expected.
###It's also structured in a way that lets you change goplat speed.

%patch $10796 $8E $E5 $83 $3E $10 $72 $00 $75 $07 $83 $3E $12 $72 $00 $74 $03
              $E9 $FE $00 $8B $44 $0E $BA

%patch $107AD $0C $00 #Horizontally moving goplat speed

%patch $107AF $F7 $EA $F7 $2E $92 $BA $A3 $10 $72 $8B $44 $10 $BA

%patch $107BC $0C $00 #Vertically moving goplat speed

%patch $107BE $F7 $EA $F7 $2E $92 $BA $A3 $12 $72 $31 $FF $81 $7C $10 $FF $FF
              $75 $03 $47 $EB $11 $81 $7C $0E $FF $FF $74 $0A $47 $47 $81 $7C
              $10 $01 $00 $75 $01 $47 $89 $F5 $D1 $E7 $89 $FE $81 $E6 $02 $00
              $8B $43 $24 $03 $84 $10 $72 $8C $E3 $89 $47 $FE $B1 $08 $D3 $E8
              $89 $C2 $39 $53 $2E $74 $A1 $31 $C9 $09 $F6 $74 $04 $89 $D3 $EB
              $03 $8B $5E $30 $81 $F9 $02 $00 $7C $0C $81 $FF $04 $00 $7C $04
              $4B $4B $EB $02 $43 $43 $D1 $E3 $8B $9F $12 $B8 $D1 $EB $D1 $E3
              $8E $06 $C2 $72 $09 $F6 $74 $05 $8B $46 $2E $EB $02 $89 $D0 $D1
              $E0 $01 $C3 $81 $F9 $01 $00 $74 $16 $7F $21 $26 $83 $3F $47 $75
              $18 $C7 $84 $10 $72 $00 $00 $C7 $46 $04 $01 $00 $E9 $4A $00 $26
              $83 $3F $46 $75 $44 $09 $F6 $74 $09 $41 $EB $9D $26 $83 $3F $46
              $74 $DF $89 $F3 $81 $C3 $10 $72 $81 $FF $04 $00 $8C $E7 $7C $13
              $C7 $42 $0E $FF $FF $8B $45 $FE $25 $FF $00 $8B $17 $29 $C2 $89
              $17 $EB $16 $C7 $42 $0E $01 $00 $8B $45 $FE $25 $FF $00 $BA $00
              $01 $29 $C2 $8B $07 $01 $D0 $89 $07 $5F $5E $8C $E4 $5D $CB

###New function to be called for each platform on a single game 'tick',
###determining which kind of platform is it (following a path or not).
###Also, if following a path, adjusts speed.

%patch $108AD $55 $89 $E5 $81 $EC $48 $00 $56 $57 $8B $76 $06 $8E $E5 $81 $3E
              $10 $72 $00 $00 $75 $1F $81 $3E $12 $72 $00 $00 $75 $17 $81 $7C
              $44 $00 $00 $75 $07 $81 $C4 $46 $00 $E9 $D0 $FE $A1 $92 $BA $BA

%patch $108DD $0C $00 #Set speed for platform following a path

%patch $108DF $E9 $5D $01

###Change code reference (pointer) in the platform segment, so the new function
###would be called on each game 'tick' (detecting the kind of platform).
%patch $22860 $0D $06 $102ARW

#####New hazard to be added#####

###A new hazard is added, taking advantage of existing graphics and
###free'd segments. It's the dangerous robotic goplat appearing in Bio Menace 3.

###This patch is responsible for the player's collision with it.
###Basically, we want the player to die upon hitting it.
###That's right, die right away, not just lose a point of health.
###Unfortunately, the large robot (type 14h) is the only thing that originally does it to the player.
###Solution: We've set type 17h for asteroid replacement - same as jumping robot.
###But now it doesn't do damage as expected. So, we change the code (somewhere in sub_C38A).
###But where do we have the room for that?
###True, free'd land mine collection code space!
%patch $C817 $81 $7C $1E $22CBRW #Is current segment first hazard frame?
             $0F $84 $6B $04
             $81 $7C $1E $22CDRW #Maybe second?
             $0F $84 $62 $04
             $E9 $A3 $04         #Jump back and have original behavior
###Update jump table accordingly!
%patch $CDA5 $97 $04

###Now, at least for the initialization of the new hazard,
###we use helicopter code.
###Lets start map side (that is, when tiles on map are scanned)...
###Change jump table first.
%patch $FA3D $E3 $05
###Now change code we jump to (from the same table).
###Among things, don't cache anything.
###We take care of caching later. Also pass map sprite num.
%patch $F8D3 $8B $46 $FA $50 $57 $56 $9A $93 $06 $102ARW $83 $C4 $06 $90 $90
             $90 $90 $90

###Finally, change helicopter initialization code. We take care of caching here.
###Furthermore, make the helicopter hide behind foreground tiles (and scorebox).
%patch $10933 $55 $89 $E5 $56 $57 $8B $76 $06 $8B $7E $08 $31 $C0 $50 $9A $54
              $0B $05D2RW $44 $44 $8B $1E $50 $44 $C7 $47 $02 $02 $00 $C7 $47
              $22 $02 $00 $89 $F0 $B1 $08 $D3 $E0 $89 $47 $0A $89 $F8 $D3 $E0
#             $22 $03 $00 $89 $F0 $B1 $08 $D3 $E0 $89 $47 $0A $89 $F8 $D3 $E0
              $89 $47 $0C $C7 $47 $0E $00 $00 $C7 $47 $10 $01 $00 $C7 $47 $06
              $00 $00 $C7 $47 $40 $01 $00 $A0 $E1 $44 $98 $BA $19 $00 $3D $03
              $00 $75 $02 $D1 $E2 $89 $57 $44 $53 $89 $FB $D1 $E3 $8B $9F $12
              $B8 $D1 $EB $D1 $E3 $8E $06 $C2 $72 $89 $F0 $D1 $E0 $01 $C3 $26
              $C7 $07 $3A $00 $5B $C7 $47 $48 $00 $00 $81 $7E $0A $49 $00 $74
              $19 $BF $8E $72 $C7 $07 $29 $00 $C7 $47 $4A $00 $01 $BA $0F $00
              $C7 $47 $54 $28 $00 $B8 $2289RW $EB $0D $BF $7E $72 $C7 $07 $17
              $00 $BA $05 $00 $B8 $22CBRW $89 $57 $52 $50 $31 $C0 $50 $53 $9A
              $25 $15 $0814RW $83 $C4 $06 $C7 $05 $01 $00 $5F $5E $5D $CB $8E
              $72 $7E $72

###Also add new code for segments ("tile collision check"; although not exactly),
###taking advantage of helicopter init code free'd space!
%patch $109F6 $55
              $8B $EC
              $56
              $8B $76 $06
              $FF $4C $52
              $7F $18
              $81 $7C $1E $22CDRW
              $75 $07
              $C7 $44 $1E $22CBRW
              $EB $05
              $C7 $44 $1E $22CDRW
              $C7 $44 $52 $05 $00 #Reset counter
              $E9 $46 $02         #Jump to the middle of a different function (for helicopter). Share code!
### WOOT! Do this to get reboot message in DOSBox! And for a real PC, reboot :)
###           $E9 $B6 $0A         #Jump to the middle of a different function (for helicopter). Share code!
###

###Now update segments for hazard (seg198 and seg199)
%patch $22CB0 $7E $01 $7E $01 #Change frame
%patch $22CB4 $02 $00         #Change movement parameter
%patch $22CB6 $00 $00         #"Change h"
%patch $22CB8 $00 $00         #"Change v"
%patch $22CBA $00 $00         #Change delay (anim speed)
%patch $22CBC $00 $00         #H anim move amount
%patch $22CBE $00 $00         #V anim move amount
%patch $22CC0 $0D $06 $102ARW #Change code to execute
%patch $22CC8 $56 $07 $102ARW #Change the tiles checking code
#%patch $22CCC $00 $00 $22CBRW
#%patch $22CCC $00 $00 $22CDRW #Change next segment/frame
%patch $22CD0 $7F $01 $7F $01 #Change frame
%patch $22CD4 $02 $00         #Change movement parameter
%patch $22CD6 $00 $00         #"Change h"
%patch $22CD8 $00 $00         #"Change v"
%patch $22CDA $00 $00         #Change delay (anim speed)
%patch $22CDC $00 $00         #H anim move amount
%patch $22CDE $00 $00         #V anim move amount
%patch $22CE0 $0D $06 $102ARW #Change code to execute
%patch $22CE8 $56 $07 $102ARW #Change the tiles checking code
#%patch $22CEC $00 $00 $22CBRW #Change next segment/frame

### Here are a few more text patches, this time for                ###
### discussions with hostages, "boss messages" and robot messages. ###
### Note that it just updates texts in segments with the space for ###
### that. The code which deals with what to display, where to      ###
### fetch the text from, in which level, etc... comes later.       ###

### Messages from hostages and Snake's responses. ###
# Level 1
%patch $21840 "Thank you very much" $0A
              "for rescuing me, Mr. Snake!" $0A
              "I've been sent over here in order" $0A
              "to bring you this key." $00
%patch $218A9 "As the city is currently in a state" $0A
              "of emergency, all gates to the" $0A
              "nearby park have been automatically" $0A
              "locked. This key should let you" $0A
              "enter the park from any of them." $00
%patch $21951 "Thanks for the key and the hint!" $0A
              "It's time to continue our chasing" $0A
              "in the park." $00
# Level 2
%patch $219A1 "Thank you!! I... I think that" $0A
              "I've seen some kind of a" $0A
              "floating head going the other way," $0A
              "bypassing the block locking the path!" $0A
              "Here's a key to unlock it." $00
%patch $21A3C "Thanks for the key." $0A
              "I do wonder what has the " $22 "head" $22 $0A
              "prepared for me..." $00
# Level 3
%patch $21A83 "Many many thanks!! It feels so scary" $0A
              "here. These insect-like creatures and" $0A
              "robots... *shudders*" $0A
              "Oh...OH! Here's some key" $0A
              "I've found. Guess it wouldn't be" $0A
              "less than useful?" $00
%patch $21B2F "Yeah, these freaks have had enough" $0A
              "surprises for me. But no worries," $0A
              "I can stand by any of them!" $0A
              "Oh, and thanks for the key!" $0A
              "Lets hope it actually leads me" $0A
              "to somewhere..." $00
#Level 5
%patch $21BDB "YIKES!...Oh, you're just an unharmful" $0A
              "human being. That skull guy" $0A
              "has scared me to death! Oh well," $0A
              "thanks. Here's some key I've found." $00
%patch $21C62 "Hmm... oh, the skull thing? It's been" $0A
              "an easy target. Lets exit now!" $00
# Level 6
%patch $21CA7 "Thank you very much! One would" $0A
              "think it's been boring, all alone" $0A
              "with the electric beam, a key," $0A
              "and some kind of a gem." $0A
              "But no, not at all! I've had" $0A
              "enough fear so far..." $00
%patch $21D52 "Hmm, yeah I know the feeling..." $0A
              "Well, the key is the important thing," $0A
              "opening the way to the exit." $0A
              "It's going to be tough, though." $00
# Level 9
%patch $21DD5 "*Talking silently*" $0A
              "Ah, Snake Logan. Thank you" $0A
              "very much. These monsters" $0A
              "have been scaring me to death." $0A
              "Oh, here's some key..." $00
%patch $21E53 "*Escaping as fast as he can*" $00
# Level 10
%patch $21E70 "Thanks for saving me! Here's" $0A
              "a key for one of the exits." $0A
              "Which way are you heading?" $00
%patch $21EC4 "Um... the far side, I suppose." $00
%patch $21EE3 "Oh gosh! Watch out over there!" $0A
              "That area has been invaded by" $0A
              "a great deal of robotic stuff." $0A
              "It's really hard to escape" $0A
              "from that!" $00
%patch $21F65 "Ah, I can bypass them." $0A
              "No problem at all." $00
# Level 12
%patch $21F8F "Whoa, I'm surprised to see that" $0A
              "you've actually survived Snake!" $0A
              "Well, I've seen some strange" $0A
              "floating head flying into the" $0A
              "emergency undergound tunnel." $0A
              "Here's a key for it." $00
%patch $2203C "Damn, that " $22 "head" $22 " always" $0A
              "getting further. But no worries," $0A
              "I've survived so far and I'm going" $0A
              "to survive the rest!" $00

### Boss messages ###
# Skull Man (Level 5)
%patch $220AE "Huh, is that Snake over there? How" $0A
              "could you even get to here?!! Oh well," $0A
              "don't think that I've forgotten" $0A
              "what you've done to my cousin!!" $00
%patch $22138 "You're surely going to pay for that!" $0A
              "Oh, and it's not going to be so easy" $0A
              "this time! Rather, the opposite!" $00
# Dr. Mangle, first encounter (In demo level 18)
%patch $221A3 "Ahh... Here's our little Loganny Snake." $0A
              "You've been so sure that after beating" $0A
              "Master Cain, it's all over, huh?" $0A
              "Well, not at all!" $00
%patch $22225 "Now... you're just entering my lab." $0A
              "You're surely not going to pass through" $0A
              "any of the radioactive devices; Nor you" $0A
              "find the anti-radiation pill.. Oh, oops." $00
# Encounter with several hostages (right before great monster fight)
%patch $222C2 "Hey you over there! SAVE US!" $0A
              "We've just been trapped by these..." $0A
              "Lizard, SNAKE, whatever. And our city..." $0A
              "our neighborhood... so sad...." $00
%patch $2234B "*A heavy monster growl can be heard*" $0A
              "AAAARRRRGGGGHHHH!!!!!!!!!!!!!!!!!!!!!!!!" $00
# Dr. Mangle, second encounter (In level 19; The very final match)
%patch $22399 "Huh... Is it just me or Snake has just" $0A
              "come out of my pit... meaning that" $0A
              "the bomb is detonated... meaning that" $0A
              "MY HOLY MONSTER HAS BEEN DEFEATED?!?!" $00
%patch $2242F "Well... I think that I don't have many" $0A
              "choices. This time, by defeating the" $0A
              "monster, it's NOT over. And, I'll surely" $0A
              "take care of YOU!!!" $00

### Robot messages ###
# First encounter (In level 1)
%patch $224B8 "Hint 1: Just in case you don't know," $0A
              "you can look up and down using the" $0A
              "PAGE UP and PAGE DOWN keys." $0A
              "SHIFT + UP/DOWN is an alternative" $0A
              "way of looking up/down." $00
%patch $22556 "Hint 2: To go up on the stairs," $0A
              "repeatedly press the jump key" $0A
              "(CTRL by default)." $0A
              "To go down, just fall down near the" $0A
              "stairs, in the quick Snake Log..." $0A
              "...err, Dangerous Dave fashion." $00
# Second encounter (In level 8)
%patch $2273C "Is that music playing in the" $0A
              "background? Well, we admit that it" $0A
              "might be an inappropriate choice" $0A
              "for this time of the day... um..." $0A
              "night. Lets try fixing it..." $00
# Third encounter (In level 12)
%patch $2260D "Further in this arena, there's a" $0A
              "blue shard locked electric beam." $0A
              "While it is VERY DANGEROUS, you CAN," $0A
              "somehow, bypass the beam, while" $0A
              "not even having any blue shard." $00
%patch $226B4 "In that case, you'd better avoid" $0A
              "from deactivating the top bridge." $0A
              $0A
              "...Oh, one more thing. Try sneaking" $0A
              "behind these large..er..robots!" $00

### This code deals with Snake's discussions with hostages.                 ###
### Rewritten code giving more possibilities for re-arrangements.           ###
### WARNINGS:                                                               ###
### 1. A standard song assignment patch for this would                      ###
### become imcompatible!!! An alternative patch is provided below.          ###
### 2. Boss messages patch MUST be applied, so new shared code can be used! ###

%patch $FA5F $55 $89 $E5 $81 $EC $CA $00 $56 $57 $FF $36 $CA $43 $68 $0F2FRW
             $68 $6B $08 $0E $E8 $11 $08 $83 $C4 $04 $89 $CE $89 $C7 $69 $F6
             $06 $00 $9A $3B $15 $14AARW $B8 $28EFRW $8A $16 $02 $9C $8E $C0
             $26 $08 $16 $30 $9C $26 $08 $16 $31 $9C $26 $08 $16 $32 $9C $26
             $08 $16 $33 $9C $68 $00 $00 $9A $E8 $18 $14AARW $44 $44 $9A $C6
             $09 $1E66RW $68

#            $0F $00 #Song to be played
             $2A $00 #Song to be played

             $9A $89 $0C $05D2RW $44 $44 $09 $FF $74 $7B $68 $09 $00 $68 $24
             $00 $9A $04 $10 $1B08RW $83 $C4 $04 $2E $FF $B4 $88 $08 $A1 $F8
             $D5 $05 $04 $00 $50 $FF $36 $F6 $D5 $9A $BA $0C $1E66RW $83 $C4
             $06 $83 $06 $00 $D6 $06 $83 $2E $FA $D5 $30 $83 $06 $F6 $D5 $30
             $2E $FF $B4 $84 $08 $2E $FF $B4 $86 $08 $16 $8D $86 $38 $FF $50
             $9A $82 $38 $0000RW $83 $C4 $08 $16 $8D $86 $38 $FF $50 $9A $3E
             $0E $1B08RW $83 $C4 $04 $9A $C5 $0A $1E66RW $68 $3C $00 $9A $C9
             $0A $1FC2RW $44 $44 $9A $B9 $08 $166DRW $9A $F7 $0E $166DRW $83
             $C6 $06 $4F $E9 $81 $FF $9A $86 $15 $14AARW $9A $3D $0D $186BRW
             $9A $97 $0B $0C38RW $9A $84 $0C $05D2RW $9A $89 $0C $05D2RW $58
             $5F $5E $89 $EC $5D $CB

#Table of text messages for discussion with hostages
#First part: For each level, how many messages (total of 25 levels).
#Second part: Array of messages, each represented by a 6 bytes block.

#%patch $FB5B $02 $02 $02 $02 $02 $02 $00 $00 $02 $02 $02 $00 $00 $00 $00 $00
#             $00 $00 $00 $00 $00 $00 $00 $00 $00

#             $2184RW $00 $00 $24 $00 $218BRW $00 $00 $27 $00
#             $2191RW $00 $00 $26 $00 $219CRW $00 $00 $27 $00
#             $21A1RW $00 $00 $25 $00 $21AARW $00 $00 $27 $00
#             $21B1RW $00 $00 $24 $00 $21BCRW $00 $00 $27 $00
#             $21C5RW $00 $00 $26 $00 $21CDRW $00 $00 $27 $00
#             $21D2RW $00 $00 $25 $00 $21DDRW $00 $00 $27 $00
#             $21E5RW $00 $00 $24 $00 $21ECRW $00 $00 $27 $00
#             $21F2RW $00 $00 $25 $00 $21FBRW $00 $00 $27 $00
#             $2203RW $00 $00 $25 $00 $220DRW $00 $00 $27 $00
#             $2216RW $00 $00 $27 $00 $2216RW $00 $00 $27 $00
#             $2216RW $00 $00 $27 $00 $2216RW $00 $00 $27 $00
#             $2216RW $00 $00 $27 $00 $2216RW $00 $00 $27 $00
#             $2216RW $00 $00 $27 $00

%patch $FB5B $03 $02 $02 $00 $02 $03 $00 $00 $02 $04 $00 $02 $00 $00 $00 $00
             $00 $00 $00 $00 $00 $00 $00 $00 $00

             $2184RW $00 $00 $24 $00 $218ARW $09 $00 $24 $00
             $2195RW $01 $00 $27 $00 $219ARW $01 $00 $26 $00
             $21A3RW $0C $00 $27 $00 $21A8RW $03 $00 $25 $00
             $21B2RW $0F $00 $27 $00 $21BDRW $0B $00 $26 $00
             $21C6RW $02 $00 $27 $00 $21CARW $07 $00 $25 $00
             $21D5RW $02 $00 $27 $00 $21D5RW $01 $00 $25 $00
             $21DDRW $05 $00 $24 $00 $21E5RW $03 $00 $24 $00
             $21E7RW $00 $00 $25 $00 $21ECRW $04 $00 $27 $00
             $21EERW $03 $00 $25 $00 $21F6RW $05 $00 $27 $00
             $21F8RW $0F $00 $24 $00 $2203RW $0C $00 $27 $00
             $2216RW $00 $00 $27 $00 $2216RW $00 $00 $27 $00
             $2216RW $00 $00 $27 $00 $2216RW $00 $00 $27 $00
             $2216RW $00 $00 $27 $00

### This code deals with boss messages (Skull Man, Dr. Mangle).   ###
### Rewritten code giving more possibilities for re-arrangements. ###

%patch $10074 $55 $89 $E5 $81 $EC $C8 $00 $56 $57 $68 $0F2FRW $68 $23 $0E $0E
              $E8 $00 $02 $83 $C4 $04 $89 $CE $89 $C7 $69 $F6 $06 $00 $9A $3B
              $15 $14AARW $9A $C6 $09 $1E66RW $09 $FF $74 $5E $68 $06 $00 $68
              $20 $00 $9A $04 $10 $1B08RW $83 $C4 $04 $83 $06 $00 $D6 $02 $2E
              $FF $B4 $3C $0E $2E $FF $B4 $3E $0E $16 $8D $86 $38 $FF $50 $9A
              $82 $38 $0000RW $83 $C4 $08 $2E $FF $A4 $40 $0E $16 $8D $86 $38
              $FF $50 $9A $3E $0E $1B08RW $83 $C4 $04 $9A $C5 $0A $1E66RW $68
              $3C $00 $9A $C9 $0A $1FC2RW $44 $44 $9A $B9 $08 $166DRW $9A $F7
              $0E $166DRW $83 $C6 $06 $4F $E9 $9E $FF $9A $86 $15 $14AARW $9A
              $97 $0B $0C38RW $9A $3D $0D $186BRW $5F $5E $89 $EC $5D $CB

### Table for boss messages. Same format as hostage messages. ###
#%patch $10113 $00 $00 $00 $00 $00 $00 $01 $00 $00 $02 $00 $02 $07 $00 $00 $00
#              $00 $00 $00 $00 $00 $00 $00 $00 $00

#              $227DRW $00 $00 $E0 $0D $2222RW $00 $00 $E0 $0D
#              $2229RW $00 $00 $E0 $0D $222FRW $00 $00 $E0 $0D
#              $2238RW $00 $00 $D2 $0E $223FRW $00 $00 $E0 $0D
#              $2249RW $00 $00 $E0 $0D $2253RW $00 $00 $E0 $0D
#              $225DRW $00 $00 $E0 $0D $2266RW $00 $00 $E0 $0D
#              $226FRW $00 $00 $E0 $0D $2278RW $00 $00 $E0 $0D
#              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
#              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
#              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
#              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
#              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
#              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
#              $2216RW $00 $00 $E0 $0D

%patch $10113 $00 $00 $00 $00 $02 $00 $00 $00 $00 $00 $00 $00 $00 $00 $00 $00
              $02 $02 $00 $02 $00 $00 $00 $00 $00

              $220ARW $0E $00 $E0 $0D $2213RW $08 $00 $E0 $0D
              $2239RW $09 $00 $E0 $0D $2242RW $0F $00 $DF $0E
              $221ARW $03 $00 $E0 $0D $2222RW $05 $00 $E0 $0D
              $222CRW $02 $00 $E0 $0D $2234RW $0B $00 $D2 $0E
              $225DRW $00 $00 $E0 $0D $2266RW $00 $00 $E0 $0D
              $226FRW $00 $00 $E0 $0D $2278RW $00 $00 $E0 $0D
              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
              $2216RW $00 $00 $E0 $0D $2216RW $00 $00 $E0 $0D
              $2216RW $00 $00 $E0 $0D

###Code to be used for one of the text messages
###(Dr. Mangle's controlled monster).
###Used to produce a monster growl sound effect.
%patch $101C2 $68 $17 $00 $9A $A5 $0A $1A3ERW $44 $44 $E9 $01 $FF
###More code for a different message (this time Dr. Mangle himself).
###Used to change music track in the table of pointers for songs and start it.
###Works ONLY in level 10h (16)! Well, unless a little value is modified.

### *** UPDATE: Due to song remapping done, we need 0Eh (14), NOT 10h (16)!!!
#%patch $101CF $C7 $06 $5E $05 $0A $00 $6A $10 $9A $89 $0C $05D2RW $44 $44 $E9
%patch $101CF $C7 $06 $5A $05 $0A $00 $6A $10 $9A $89 $0C $05D2RW $44 $44 $E9
              $EF $FE

###NOW, using free'd code space, we write shared code for
###boss messages, hostage messages and robot messages.

%patch $10287 $55 $89 $E5 $56 $8B $76 $06 $8E $46 $08 $31 $C0 $31 $DB $31 $C9
              $26 $8A $00 $3B $1E $C0 $44 $7D $05 $01 $C1 $43 $EB $F2 $5E $5D
              $CB

### This code deals with robot messages.                                    ###
### WARNINGS:                                                               ###
### 1. A standard song assignment patch for this would                      ###
### become imcompatible!!! An alternative patch is provided below.          ###
### 2. Due to lack of space in the original code, we used free'd space from ###
### the "hostage messages" code for the table of messages.                  ###
### This means that the hostage messages patch MUST be applied.             ###
### 3. Boss messages patch MUST be applied, so new shared code can be used! ###
%patch $FFB5 $55 $89 $E5 $81 $EC $C8 $00 $56 $57 $FF $36 $CA $43 $81 $3E $C0
             $44

             $06 $00 #Unique level, for which we do NOT change song
                     #(may even be bigger than 25; e.g. a special signal).
                     #Also doesn't read table's header.
                     #WARNING: It MUST be patched in another location as well!

             $74 $1D $68

#            $0F $00 #Song to be played on "ordinary" levels.
             $2A $00 #Song to be played on "ordinary" levels.

             $9A $89 $0C $05D2RW $44 $44 $68 $0F2FRW $68 $48 $0C $0E $E8 $A9
             $02 $83 $C4 $04 $89 $CE $89 $C7 $EB $06 $BF

             $00 $00 #For unique level, sets amount of successive messages to display.

             $BE

             $00 $00 #For unique level, sets initial message index in table.

             $C1 $E6 $02 $9A $C6 $09 $1E66RW $09 $FF $74 $5E $68 $08 $00 $68
             $1E $00 $9A $04 $10 $1B08RW $83 $C4 $04 $83 $06 $00 $D6 $02 $2E
             $FF $B4 $61 $0C $2E $FF $B4 $63 $0C $16 $8D $86 $38 $FF $50 $9A
             $82 $38 $0000RW $83 $C4 $08 $16 $8D $86 $38 $FF $50 $9A $3E $0E
             $1B08RW $83 $C4 $04 $9A $C5 $0A $1E66RW $68 $3C $00 $9A $C9 $0A
             $1FC2RW $44 $44 $9A $B9 $08 $166DRW $9A $F7 $0E $166DRW $9A $3D
             $0D $186BRW $83 $C6 $04 $4F $E9 $9E $FF $81 $3E $C0 $44

             $06 $00 #Again the same unique level we've mentioned.
                     #As before, BOTH have to be patched!

             $74 $0A $9A $84 $0C $05D2RW $9A $89 $0C $05D2RW $58 $5F $5E $89
             $EC $5D $CB

### Table for robot messages. Same format as hostage messages.             ###
### IMPORTANT DIFFERENCE: Free'd space from hostage messages code is used! ###
#%patch $FF38 $01 $00 $00 $00 $00 $00 $00 $00 $00 $00 $00 $00 $00 $00 $00 $00
#             $00 $00 $00 $00 $00 $00 $00 $00 $00

#             $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00
#             $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00
#             $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00
#             $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00
#             $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00
#             $2216RW $00 $00

%patch $FF38 $02 $00 $00 $00 $00 $00 $00 $01 $00 $00 $00 $02 $00 $00 $00 $00
             $00 $00 $00 $00 $00 $00 $00 $00 $00

             $224BRW $08 $00 $2255RW $06 $00 $2273RW $0C $00 $2260RW $0D $00
             $226BRW $04 $00 $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00
             $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00
             $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00
             $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00 $2216RW $00 $00
             $2216RW $00 $00

### The following patches deal with level assignments ###
%patch $5B6F $8B $1E $C0 $44 $2E $8A $87 $55 $07 $24 $01 $74 $14 $83 $3E $E8
             $44 $01 $75 $0D $2E $8A $9F $6E $07 $C7 $06 $E8 $44 $00 $00 $74
             $05 $2E $8A $9F $3C $07 $2E $8A $87 $55 $07 $88 $C2 $24 $02 $74
             $15 $C0 $EA $04 $30 $F6 $C7 $06 $58 $44 $00 $00 $53 $52 $9A $BE
             $01 $04F9RW $44 $44 $5B $88 $1E $C0 $44 $E9 $8C $00

### A few tables for level assignments ###
%patch $5BBC $01 $02 $03 $04 $05 $06 $07 $08 $09 $0A $0B $12
             $0D $0E $0F $13 $0C $10 $0F $10 $04 $06 $09 $12 $0C
#WARNING: Works, but some demos must be set appropriately for in-game usage.
%patch $5BD5 $00 $00 $22 $01 $00 $01 $00 $00 $01 $32 $00 $01
             $00 $00 $00 $00 $42 $00 $00 $00 $00 $00 $00 $00 $00
%patch $5BEE $01 $02 $03 $14 $05 $15 $07 $08 $16 $0A $0B $17
             $0D $0E $0F $13 $0F $12 $0C $12 $04 $06 $09 $10 $0C
#%patch $5BBC $01 $02 $03 $04 $05 $06 $07 $08 $09 $0A $0B $0C
#             $0D $0E $0F $10 $11 $12 $13 $14 $03 $06 $09 $0B $0C
##WARNING: Works, but some demos must be set appropriate for in-game usage.
#%patch $5BD5 $00 $00 $01 $00 $00 $01 $00 $00 $01 $00 $01 $00
#             $00 $00 $00 $00 $00 $00 $00 $00 $42 $42 $42 $42 $00
#%patch $5BEE $01 $02 $14 $04 $05 $15 $07 $08 $16 $0A $17 $0C
#             $0D $0E $0F $10 $11 $12 $13 $14 $15 $16 $17 $18 $0C

%end
